Skip to content
Related Articles

Related Articles

Improve Article

Customizing termination behavior for uncaught exception In C++

  • Last Updated : 15 Apr, 2018

Whenever an exception arises in C++, it is handled as per the behavior defined using the try-catch block. However, there is often the case when an exception is thrown but isn’t caught because the exception handling subsystem fails to find a matching catch block for that particular exception. In that case, the following set of actions takes place:

  1. The exception handling subsystem calls the function: unexpected(). This function, provided by the default C++ library, defines the behavior when an uncaught exception arises. By default, unexpected calls terminate().
  2. The terminate function defines the actions that are to be performed during process termination. This, by default, calls abort().
  3. The process is aborted.

The terminate() and unexpected() simply call other functions to actually handle an error. As explained above, terminate calls abort(), and unexpected() calls terminate(). Thus, both functions halt the program execution when an exception handling error occurs. However, you can change the way termination occurs.

To change the terminate handler, the function used is set_terminate(terminate_handler newhandler), which is defined in the header <exception>.

The following program demonstrates how to set a custom termination handler:




// CPP program to set a new termination handler
// for uncaught exceptions.
#include <exception>
#include <iostream>
using namespace std;
  
// definition of custom termination function
void myhandler()
{
    cout << "Inside new terminate handler\n";
    abort();
}
  
int main()
{
    // set new terminate handler
    set_terminate(myhandler); 
    try {
        cout << "Inside try block\n";
        throw 100;
    }
    catch (char a) // won't catch an int exception
    {
        cout << "Inside catch block\n";
    }
    return 0;
}

Output:

Inside try block
Inside new terminate handler


Runtime Error:

Abort signal from abort(3) (SIGABRT)

It is to be duly noted that the only thing that your custom terminate handler must do is stop the program execution. It must not return to the program or resume it in any way.

Want to learn from the best curated videos and practice problems, check out the C++ Foundation Course for Basic to Advanced C++ and C++ STL Course for foundation plus STL.  To complete your preparation from learning a language to DS Algo and many more,  please refer Complete Interview Preparation Course.
My Personal Notes arrow_drop_up
Recommended Articles
Page :